%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                          %                     
%Interpolación de Lagrange %
%                          %                      
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Parámetros de Entrada:

%x,y:Vectores que guardan los números de los pares ordenado (xi,yi)
%    para i=0,1,2,....,n donde x0<x1<x2<...<xn.

%newx:Vector de elementos para los cuales se estimarán mediante la Interpolación
%     Lagrange.

function[newy]=ILagrange(x,y,newx)
	n1=length(x);%Obtenemos el número de elementos de x.
	n2=length(newx);%Obtenemos el número de elementos de newx.
    Lk=zeros(n1,n2);%Matriz que guarda los valores Lk.
    prodLk=1;%Variable para realizar el producto Lk.
    for i=(1:n2)
        for k=(1:n1)
            for j=(1:n1)
                if(j~=k)
    				prodLk=prodLk*((newx(i)-x(j))/(x(k)-x(j)));%Obtenemos cada 
                    %valor Lk.
                end
            end
            Lk(k,i)=prodLk;%%Guardamos el valor Lk correspondiente.
            prodLk=1;
        end
    end
    %Obtenemos los nuevos valores de newy.
    newy=(y'*Lk)';
end  

%Parámetros de Salida:

%newy:Nuevos puntos estimados mediante el polinomio de Lagrange.