%%%%%%%%%%%%%%%%%%%%%%%%%%
%                        %                     
%Interpolación Lineal    %
%                        %                      
%%%%%%%%%%%%%%%%%%%%%%%%%%

%Parámetros de Entrada:

%x,y:Vectores que guardan los números de los pares ordenado (xi,yi)
%    para i=0,1,2,....,n donde x0<x1<x2<...<xn.

%newx:Vector de elementos para los cuales se estimarán mediante la Interpolación
%     Lineal.

function[newy]=ILineal(x,y,newx)
	n1=length(x);%Obtenemos el número de elementos de x.
	n2=length(newx);%Obtenemos el número de elementos de newx.
    newy=zeros(n2,1);%Vector que guardará los nuevos valores de y.

    %Calculamos la pendiente de la recta.
    s=zeros(n1-1,1);
    h=zeros(n1-1,1);
    for i=(1:n1-1)
    	h(i)=x(i+1)-x(i);
    	s(i)=(y(i+1)-y(i))/h(i);
    end
    %Encontramos el nuevo punto para determinar a que recta pertenece.
	for i=(1:n2)
		distancia=abs(min(x)-max(x));
		for j=(1:n1)
			if(abs(newx(i)-x(j))<distancia)
				distancia=abs(newx(i)-x(j));
				indx=j;
			end
		end
		%Aproximamos los nuevos puntos y.
		if(newx(i)<x(indx))
			indx=indx-1;
			newy(i)=y(indx)+s(indx)*(newx(i)-x(indx));
		elseif(newx(i)>x(indx))
			newy(i)=y(indx)+s(indx)*(newx(i)-x(indx));
        elseif((newx(i)-x(indx))<10^-8)
            newy(i)=y(indx);
		end
	end
end
%Parámetros de Salida:

%newy:Nuevos puntos estimados mediante Interpolación Lineal.