function [zi] = Inter3D(xi,yi,x,y,z,n,md)
    nxi=length(xi);
    zi=zeros(nxi,1);

    %Creamos la malla 
    
    [x,y,z] = CMalla(x,y,z,n);
    zip=zeros(length(z(:,1)),1);
    
    switch (md)
        case 1    
            for j=(1:nxi)
                for i=(1:length(z(:,1)))
                    zip(i)=SCNatural(x(1,:)',z(i,:)',xi(j));
                end
                zi(j)=SCNatural(y(:,1),zip,yi(j));
            end
        case 2
            for j=(1:nxi)
                for i=(1:length(z(:,1)))
                    zip(i)=SCNKnot(x(1,:)',z(i,:)',xi(j));
                end
                zi(j)=SCNKnot(y(:,1),zip,yi(j));
            end   
        case 3
            for j=(1:nxi)
                for i=(1:length(z(:,1)))
                    zip(i)=ILineal(x(1,:)',z(i,:)',xi(j));
                end
                zi(j)=ILineal(y(:,1),zip,yi(j));
            end  
        case 4
            for j=(1:nxi)
                for i=(1:length(z(:,1)))
                    zip(i)=ICAkima(x(1,:)',z(i,:)',xi(j));
                end
                zi(j)=ICAkima(y(:,1),zip,yi(j));
            end  
        case 5
            for j=(1:nxi)
                for i=(1:length(z(:,1)))
                    zip(i)=ICCons(x(1,:)',z(i,:)',xi(j));
                end
                zi(j)=ICCons(y(:,1),zip,yi(j));
            end  
        case 6
            for j=(1:nxi)
                for i=(1:length(z(:,1)))
                    zip(i)=MPIH(x(1,:)',z(i,:)',xi(j));
                end
                zi(j)=MPIH(y(:,1),zip,yi(j));
            end  
        case 7
            for j=(1:nxi)
                for i=(1:length(z(:,1)))
                    zip(i)=ILagrange(x(1,:)',z(i,:)',xi(j));
                end
                zi(j)=ILagrange(y(:,1),zip,yi(j));
            end  
        case 8
            for j=(1:nxi)
                for i=(1:length(z(:,1)))
                    zip(i)=INewton(x(1,:)',z(i,:)',xi(j));
                end
                zi(j)=INewton(y(:,1),zip,yi(j));
            end  
    end
end

