%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                  %
% Interpolacin Bivariada de Akima %
%               Malla              %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Parmetros de Entrada:

%ncp: Nmero de puntos cercanos para la aproximacin de las derivadas
%     parciales zx,zy,zxx,zxy,zyy

%x,y,z: Puntos (xi,yi,zi) donde se realiza la interpolacin

%xi,yi: Vectores que contienen los puntos a estimar


function [X,Y,Z,Xtemp,Ytemp,zi] = idsfft2(x,y,z,xi,yi,n,md)

    %Clculos preeliminares 
    
    nxi=length(xi);
    nyi=length(yi);
    X=zeros(nyi,nxi);
    Xtemp=zeros(nyi*nxi,1);
    Y=zeros(nyi,nxi);
    Ytemp=zeros(nyi*nxi,1);
    Z=zeros(nyi,nxi);
    ixi=0;
    iyi=0;
    izi=0;
    
    %Creamos las malla xi, yi
    for i=(1:nxi)
        for j=(1:nyi)
            ixi=ixi+1;
            iyi=iyi+1;
            Xtemp(ixi)=xi(i);
            X(j,i)=xi(i);
            Ytemp(iyi)=yi(j);
            Y(j,i)=yi(j);
        end
    end
    
    %Estimamos los puntos zi de la malla
    [zi]= Inter3D(Xtemp,Ytemp,x,y,z,n,md);
    for i=(1:nxi)
        for j=(1:nyi)
            izi=izi+1;
            Z(j,i)=zi(izi);
        end
    end
end

%Parmetros de salida 

%X,Y,Z: Matrices bidimencionales para crear la malla

%Xv,Yv,Zv: Vectores que contienen todos los puntos de la malla.

