%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                          %             
%Función que encuentra los puntos cercanos %
%                                          %                      
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%Parámetros de Entrada:

%xd,yd:Vectores que guardan los números de (xi,yi).

%ncp: Número de puntos cercanos requeridos (mínimo 3).

function[ipc]=idcldp (xd, yd, ncp)
    
    %Función para calcular distancias.
	
    function[dis]= dsqf(x1,y1,x2,y2)
		dis=(x2-x1)^2+(y2-y1)^2;
    end

    %Proceso preeliminar.
	
    ndp=length(xd);
	ipc=zeros(ndp*ncp,1);
	dis0=zeros(ndp,1);
	iip0=0;
    
    %Obtenemos los puntos cercanos.
    
	for i=(1:ndp)
        if(i<ndp)
            for j=(i+1:ndp)
                dis0(j)= dsqf(xd(i),yd(i),xd(j),yd(j));
            end
        end
        if(i>1)
            for j=(1:i-1)
                dis0(j)= dsqf(xd(i),yd(i),xd(j),yd(j));
            end
        end
		maxim=max(dis0)+1;
		dis0(i)=maxim;
        for j=(1:ncp)
			iip0=iip0+1;
			[~,ipc0]=min(dis0);
			ipc(iip0)=ipc0;
            dis0(ipc0)=maxim;
        end
        dis0=zeros(ndp,1);
	end
end

%Parámetros de Salida:

%ipc: Índice de los puintos cercanos.