%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                 	%                     
%Encuentra el punto en el triángulo %
%                                 	%                    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Parámetros de entrada:

%nt:Número de triángulos.

%ipt: Índice de los vértices de los triángulos.

%nl: Número de lineas que conforman en borde de la triangular.

%ipl: Índice de los puntos que conforman las nl.

%xii,yii: Punto (xi,yi) que se ubicará dentro del triágulo correspondiente.

%iwp,iwk: Vectores que guardan información de la malla.

function [iti,iwk, wk] =idlctn(xd, yd, nt, ipt, nl, ipl, xii, yii,iwk,wk)
    
	%Variables globales 
	
	global idlc
	global nit

	global i1
	global i2
	global i3
	global idp
	global il1
	global il1t3
	global il2
	global ip1
	global ip2
	global ip3
	global isc
	global it0
	global it0t3
	global itipv
	global itsc
	global jiwk
	global jwk
	global ndp0
	global nl0
	global nt0
	global ntl
	global ntsci
	global x0
	global x1
	global x2
	global x3
	global xi
	global xmn
	global xmx
	global xs1
	global xs2
	global y0
	global y1
	global y2
	global y3
	global yi
	global ymn
	global ymx
	global ys1
	global ys2
	global ntsc
	global idsc
	ndp=length(xd);
	
	%Vectores necesarios para los cálculos.
	
	iwk=iwk(1:18*ndp,1);
	wk=wk(1:8*ndp,1);
	
	%Funciones para el cálculo.
	
    function[lado]=side(u1,v1,u2,v2,u3,v3)
        lado=(u1-u3)*(v2-v3) - (v1-v3)*(u2-u3);
    end
    function[resultado]=spdt(u1,v1,u2,v2,u3,v3)
        resultado=(u1-u2)*(u3-u2) + (v1-v2)*(v3-v2);
    end
	
	%Proceso preeliminar.
	
    ndp0 = ndp;
    nt0 = nt;
    nl0 = nl;
    ntl = nt0 + nl0;
    x0 = xii;
    y0 = yii;
	
	%Comenzamos con la ubicación dentro de la malla triangular.
	
    if( nit==0)
        nit = 1;
        xmn = xd(1);
        xmx = xmn;
        ymn = yd(1);
         ymx = ymn;
       
        for idp = (2:ndp0)
            xi = xd(idp);
            yi = yd(idp);
            xmn = min (xi,xmn);
            xmx = max (xi,xmx);
            ymn = min (yi,ymn);
            ymx = max (yi,ymx);
        end 
        xs1 = ( xmn + xmn + xmx ) / 3;
        xs2 = ( xmn + xmx + xmx ) / 3;
        ys1 = ( ymn + ymn + ymx ) / 3;
        ys2 = ( ymn + ymx + ymx ) / 3;
        
        ntsc(1:9) = 0;
        idsc(1:9) = 0;
        it0t3 = 0;
        jwk = 0;
        
        for it0 = (1:nt0)
            it0t3 = it0t3 + 3;
            i1 = ipt(it0t3-2);
            i2 = ipt(it0t3-1);
            i3 = ipt(it0t3);
            xmn = min ([xd(i1),xd(i2),xd(i3)]);
            xmx = max ([xd(i1),xd(i2),xd(i3)]);
            ymn = min ([yd(i1),yd(i2),yd(i3)]);
            ymx = max ([yd(i1),yd(i2),yd(i3)]);
            if (~(ymn>ys1))
                if(xmn<=xs1)
                    idsc(1) = 1;
                end
                if (xmx>=xs1 && xmn<=xs2)
                    idsc(2) = 1;
                end
                if (xmx>=xs2)
                    idsc(3) = 1;
                end
                
                if (~(ymx<ys1 || ymn>ys2))
                    if (xmn<=xs1) 
                        idsc(4) = 1;
                    end
                    if (xmx>=xs1 && xmn<=xs2) 
                        idsc(5) = 1;
                    end
                    if (xmx>=xs2) 
                        idsc(6) = 1;
                    end
                    
                     if (~(ymx<ys2))
                         if (xmn<=xs1) 
                             idsc(7) = 1;
                         end
                         if (xmx>=xs1 && xmn<=xs2) 
                             idsc(8) = 1;
                         end
                         if (xmx>=xs2) 
                             idsc(9) = 1;
                         end
                         
                     end
                else
                 
                     if (~(ymx<ys2))
                         if (xmn<=xs1) 
                             idsc(7) = 1;
                         end
                         if (xmx>=xs1 && xmn<=xs2) 
                             idsc(8) = 1;
                         end
                         if (xmx>=xs2) 
                             idsc(9) = 1;
                         end       
                     end
                end
            else
                
                if (~(ymx<ys1 || ymn>ys2))
                    if (xmn<=xs1) 
                        idsc(4) = 1;
                    end
                    if (xmx>=xs1 && xmn<=xs2) 
                        idsc(5) = 1;
                    end
                    if (xmx>=xs2) 
                        idsc(6) = 1;
                    end
                    
                     if (~(ymx<ys2))
                         if (xmn<=xs1) 
                             idsc(7) = 1;
                         end
                         if (xmx>=xs1 && xmn<=xs2) 
                             idsc(8) = 1;
                         end
                         if (xmx>=xs2) 
                             idsc(9) = 1;
                         end
                         
                     end
                else
                 
                     if (~(ymx<ys2))
                         if (xmn<=xs1) 
                             idsc(7) = 1;
                         end
                         if (xmx>=xs1 && xmn<=xs2) 
                             idsc(8) = 1;
                         end
                         if (xmx>=xs2) 
                             idsc(9) = 1;
                         end       
                     end
                end

            end
        
		%Guardamos le información de la malla trangular.
                
            for isc =(1:9)
                if ( idsc(isc) ~= 0 )
                    jiwk = 9*ntsc(isc) + isc;
                    iwk(jiwk) = it0;
                    ntsc(isc) = ntsc(isc) + 1;
                    idsc(isc) = 0;
                end 
            end
        
            jwk = jwk + 4;
            wk(jwk-3) = xmn;
            wk(jwk-2) = xmx;
            wk(jwk-1) = ymn;
            wk(jwk) = ymx;
        end
        
        isc = 1;
        if (x0>=xs1) 
            isc = isc + 1;
        end
        if (x0>=xs2) 
            isc = isc + 1;
        end
        if (y0>=ys1) 
            isc = isc + 3;
        end
        if (y0>=ys2) 
            isc = isc + 3;
        end
        
        ntsci = ntsc(isc);
            if (~(ntsci<=0))
                jiwk = -9 + isc;
                for itsc = (1:ntsci)
                    jiwk = jiwk + 9;
                    it0 = iwk(jiwk);
                    jwk = it0*4;
                    if (x0<wk(jwk-3))
                        ok1=1;
                        continue;
                    end
                    if (x0>wk(jwk-2))
                        ok1=1;
                        continue;
                    end
                    if (y0<wk(jwk-1))
                        ok1=1;
                        continue;
                    end
                    if (y0>wk(jwk)) 
                        ok1=1;
                        continue;      
                    end
                    it0t3 = it0*3;
                    ip1 = ipt(it0t3-2);
                    x1 = xd(ip1);
                    y1 = yd(ip1);
                    ip2 = ipt(it0t3-1);
                    x2 = xd(ip2);
                    y2 = yd(ip2);
                    if (side(x1,y1,x2,y2,x0,y0)<0) 
                        ok1=1;
                        continue;  
                    end
                    ip3 = ipt(it0t3);
                    x3 = xd(ip3);
                    y3 = yd(ip3);
                    if (side(x2,y2,x3,y3,x0,y0)<0 ) 
                        ok1=1;
                        continue;
                    end
                    if (side(x3,y3,x1,y1,x0,y0)<0 ) 
                        ok1=1;
                        continue;
                    end
                    ok1=2;
                    break;
                end
                if(ok1==2)
                    iti = it0;
                    itipv = it0;
					
					% Obtenemos el índice del triángulo donde se encuentra (xii,yii).
					
                    return;
                elseif(ok1==1)
                        
                    for il1 = (1:nl0)
                        il1t3 = il1*3;
                        ip1 = ipl(il1t3-2);
                        x1 = xd(ip1);
                        y1 = yd(ip1);
                        ip2 = ipl(il1t3-1);
                        x2 = xd(ip2);
                        y2 = yd(ip2);
                        if (spdt(x2,y2,x1,y1,x0,y0)<0 )
                            ok2=2;
                            continue;
                        end
                        if (~(spdt(x1,y1,x2,y2,x0,y0)<0)) 
                            if (side(x1,y1,x2,y2,x0,y0)>0) 
                                ok2=2;
                                continue;
                            end
                            il2 = il1;
                            ok2=1;
                            break;
                                
                        else
                            
                            il2 = mod(il1,nl0) + 1;
                            ip3 = ipl(3*il2-1);
                            x3 = xd(ip3);
                            y3 = yd(ip3);
                            if (spdt(x3,y3,x2,y2,x0,y0)<=0)
                                ok2=1;
                                break;
                            end
                        end
                            
                        ok2=2;
                    end
                    if(ok2==2)
                        it0=1;
                        iti = it0;
                        itipv = it0;
						
						% Obtenemos el índice del triángulo donde se encuentra (xii,yii).
						
                        return;
                    elseif(ok2==1)
                        it0 = il1*ntl + il2;
                        iti = it0;
                        itipv = it0;
						
						% Obtenemos el índice del triángulo donde se encuentra (xii,yii).
						
                        return;
                    end
        

                end
                        
       
            else
                
                for il1 = (1:nl0)
                    il1t3 = il1*3;
                    ip1 = ipl(il1t3-2);
                    x1 = xd(ip1);
                    y1 = yd(ip1);
                    ip2 = ipl(il1t3-1);
                    x2 = xd(ip2);
                    y2 = yd(ip2);
                    if (spdt(x2,y2,x1,y1,x0,y0)<0 )
                        ok2=2;
                        continue;
                    end
                    if (~(spdt(x1,y1,x2,y2,x0,y0)<0)) 
                        if (side(x1,y1,x2,y2,x0,y0)>0) 
                            ok2=2;
                            continue;
                        end
                        il2 = il1;
                        ok2=1;
                        break;
                                
                    else
                        
                        il2 = mod(il1,nl0) + 1;
                        ip3 = ipl(3*il2-1);
                        x3 = xd(ip3);
                        y3 = yd(ip3);
                        if (spdt(x3,y3,x2,y2,x0,y0)<=0)
                            ok2=1;
                            break;
                        end
                     end
                            
                    ok2=2;
                end
                if(ok2==2)
                    it0=1;
                    iti = it0;
                    itipv = it0;
					
					% Obtenemos el índice del triángulo donde se encuentra (xii,yii).
                    
					return;
                elseif(ok2==1)
                    it0 = il1*ntl + il2;
                    iti = it0;
                    itipv = it0;
					
					% Obtenemos el índice del triángulo donde se encuentra (xii,yii).
					
                    return;
                end                
            end
    else
        
            it0 = itipv;
            for i=(1:1)
                if (~(it0>nt0))
                    it0t3 = it0*3;
                    ip1 = ipt(it0t3-2);
                    x1 = xd(ip1);
                    y1 = yd(ip1);
                    ip2 = ipt(it0t3-1);
                    x2 = xd(ip2);
                    y2 = yd(ip2);
                    if (side(x1,y1,x2,y2,x0,y0)<0 )
                        ok3=1;
                        break;
                    end
                    ip3 = ipt(it0t3);
                    x3 = xd(ip3);
                    y3 = yd(ip3);
                    if (side(x2,y2,x3,y3,x0,y0)<0.0D+00 ) 
                        ok3=1;
                        break;
                    end
                    if (side(x3,y3,x1,y1,x0,y0)<0.0D+00 ) 
                        ok3=1;
                        break;
                    end
                    ok3=2;
                    break;
                else
                    il1 = floor(it0/ntl);
                    il2 = it0 - il1*ntl;
                    il1t3 = il1*3;
                    ip1 = ipl(il1t3-2);
                    x1 = xd(ip1);
                    y1 = yd(ip1);
                    ip2 = ipl(il1t3-1);
                    x2 = xd(ip2);
                    y2 = yd(ip2);
                    if (~(il2~=il1)) 
                        if (spdt(x1,y1,x2,y2,x0,y0)<0 )
                            ok3=1;
                            break;
                        end
                        if (spdt(x2,y2,x1,y1,x0,y0)<0.0D+00 ) 
                            ok3=1;
                            break;
                        end
                        if (side(x1,y1,x2,y2,x0,y0)>0.0D+00 ) 
                            ok3=1;
                            break;
                        end
                        ok3=2;
                        break;
                    else
                        if (spdt(x1,y1,x2,y2,x0,y0)>0 ) 
                            ok3=1;
                            break;
                        end
                        ip3 = ipl(3*il2-1);
                        x3 = xd(ip3);
                        y3 = yd(ip3);
                        if (spdt(x3,y3,x2,y2,x0,y0)<=0 ) 
                            ok3=2;
                            break;
                        end
                        ok3=1;
                        break;
                    end
                end
            end
            if(ok3==2)
                iti = it0;
                itipv = it0;
				
				% Obtenemos el índice del triángulo donde se encuentra (xii,yii).
				
                return;
            elseif(ok3==1)
            
                isc = 1;
                if (x0>=xs1) 
                    isc = isc + 1;
                end
                if (x0>=xs2) 
                    isc = isc + 1;
                end
                if (y0>=ys1) 
                    isc = isc + 3;
                end
                if (y0>=ys2) 
                    isc = isc + 3;
                end
                ntsci = ntsc(isc);
                if (~(ntsci<=0))
                    jiwk = -9 + isc;
                    for itsc = (1:ntsci)
                        jiwk = jiwk + 9;
                        it0 = iwk(jiwk);
                        jwk = it0*4;
                        if (x0<wk(jwk-3))
                            ok1=1;
                            continue;
                        end
                        if (x0>wk(jwk-2))
                            ok1=1;
                            continue;
                        end
                        if (y0<wk(jwk-1))
                            ok1=1;
                            continue;
                        end
                        if (y0>wk(jwk)) 
                            ok1=1;
                            continue;      
                        end
                        it0t3 = it0*3;
                        ip1 = ipt(it0t3-2);
                        x1 = xd(ip1);
                        y1 = yd(ip1);
                        ip2 = ipt(it0t3-1);
                        x2 = xd(ip2);
                        y2 = yd(ip2);
                        if (side(x1,y1,x2,y2,x0,y0)<0) 
                            ok1=1;
                            continue;  
                        end
                        ip3 = ipt(it0t3);
                        x3 = xd(ip3);
                        y3 = yd(ip3);
                        if (side(x2,y2,x3,y3,x0,y0)<0 ) 
                            ok1=1;
                            continue;
                        end
                        if (side(x3,y3,x1,y1,x0,y0)<0 ) 
                            ok1=1;
                            continue;
                        end
                        ok1=2;
                        break;
                    end
                    if(ok1==2)
                        iti = it0;
                        itipv = it0;
						
						% Obtenemos el índice del triángulo donde se encuentra (xii,yii).
						
                        return;
                    elseif(ok1==1)
                        
                        for il1 = (1:nl0)
                            il1t3 = il1*3;
                            ip1 = ipl(il1t3-2);
                            x1 = xd(ip1);
                            y1 = yd(ip1);
                            ip2 = ipl(il1t3-1);
                            x2 = xd(ip2);
                            y2 = yd(ip2);
                            if (spdt(x2,y2,x1,y1,x0,y0)<0 )
                                ok2=2;
                                continue;
                            end
                            if (~(spdt(x1,y1,x2,y2,x0,y0)<0)) 
                                if (side(x1,y1,x2,y2,x0,y0)>0) 
                                    ok2=2;
                                    continue;
                                end
                                il2 = il1;
                                ok2=1;
                             break;
                                
                            else
                                
                                il2 = mod(il1,nl0) + 1;
                                ip3 = ipl(3*il2-1);
                                x3 = xd(ip3);
                                y3 = yd(ip3);
                                if (spdt(x3,y3,x2,y2,x0,y0)<=0)
                                    ok2=1;
                                    break;
                                end
                            end
                            
                            ok2=2;
                        end
                        if(ok2==2)
                            it0=1;
                            iti = it0;
                            itipv = it0;
							
							% Obtenemos el índice del triángulo donde se encuentra (xii,yii).
							
                            return;
                        elseif(ok2==1)
                            it0 = il1*ntl + il2;
                            iti = it0;
                            itipv = it0;
							
							% Obtenemos el índice del triángulo donde se encuentra (xii,yii).
							
                            return;
                        end
        

                    end
                        
       
                else
                    
                    for il1 = (1:nl0)
                        il1t3 = il1*3;
                        ip1 = ipl(il1t3-2);
                        x1 = xd(ip1);
                        y1 = yd(ip1);
                        ip2 = ipl(il1t3-1);
                        x2 = xd(ip2);
                        y2 = yd(ip2);
                        if (spdt(x2,y2,x1,y1,x0,y0)<0 )
                            ok2=2;
                            continue;
                        end
                        if (~(spdt(x1,y1,x2,y2,x0,y0)<0)) 
                            if (side(x1,y1,x2,y2,x0,y0)>0) 
                                ok2=2;
                                continue;
                            end
                            il2 = il1;
                            ok2=1;
                            break;
                                
                        else
                            
                            il2 = mod(il1,nl0) + 1;
                            ip3 = ipl(3*il2-1);
                            x3 = xd(ip3);
                            y3 = yd(ip3);
                            if (spdt(x3,y3,x2,y2,x0,y0)<=0)
                                ok2=1;
                                break;
                            end
                        end
                            
                        ok2=2;
                    end
                    if(ok2==2)
                        it0=1;
                        iti = it0;
                        itipv = it0;
						
						% Obtenemos el índice del triángulo donde se encuentra (xii,yii).
						
                        return;
                    elseif(ok2==1)
                        it0 = il1*ntl + il2;
                        iti = it0;
                        itipv = it0;
						% Obtenemos el índice del triángulo donde se encuentra (xii,yii).
						
                        return;
                    end                
                end
                
            end
                              
    end
end

%Parámetros de salida:

%iti: índice del triángulo donde se encuentra el punto (xii,yii).

%iwk,wk: Vectores que guardan información de la triangulación.



